#include <libgupnp/gupnp.h>
#include <stdlib.h>
#include <gmodule.h>
#include <AVTransport.c>
#include <RenderingControl.c>
#include <ConnectionManager.c>

static gboolean status;

/*
 * AVTransport Action handlers
 */


/*
 * AVTransport State Variable query handlers
 */

/*
 * ConnectionManager Action handlers
 */

/* GetProtocolInfo */

G_MODULE_EXPORT void get_protocol_info_cb( GUPnPService *service,
                                           GUPnPServiceAction *action,
                                           G_GNUC_UNUSED gpointer user_data )
{
    GString source;
    GString sink;

    /* Get the new target value */
    gupnp_service_action_get (action,
                              "Source", G_TYPE_STRING, &source,
                              "Sink", G_TYPE_STRING, &sink,
                              NULL);

    /* TODO */

    g_print ("get_protocol_info_cb");

    /* Return success to the client */
    gupnp_service_action_return (action);
}

/* PrepareForConnection */

G_MODULE_EXPORT void prepare_for_connection_cb( GUPnPService *service,
                                                GUPnPServiceAction    *action,
                                                G_GNUC_UNUSED gpointer user_data)
{
    /* TODO */

    g_print ("prepare_for_connection_cb");
}

/* ConnectionComplete */

G_MODULE_EXPORT void connection_complete_cb( GUPnPService *service,
                                             GUPnPServiceAction    *action,
                                             G_GNUC_UNUSED gpointer user_data)
{
    /* TODO */

    g_print ("connection_complete_cb");
}

/* GetCurrentConnectionIDs */

G_MODULE_EXPORT void get_current_connection_ids_cb( GUPnPService *service,
                                                    GUPnPServiceAction    *action,
                                                    G_GNUC_UNUSED gpointer user_data)
{
    /* TODO */

    g_print ("get_current_connection_ids_cb");
}

/* GetCurrentConnectionInfo */

G_MODULE_EXPORT void get_current_connection_info_cb( GUPnPService *service,
                                                     GUPnPServiceAction    *action,
                                                     G_GNUC_UNUSED gpointer user_data)
{
    /* TODO */

    g_print ("get_current_connection_info_cb");
}

/* GetRendererItemInfo */

G_MODULE_EXPORT void get_renderer_item_info_cb( GUPnPService *service,
                                                GUPnPServiceAction    *action,
                                                G_GNUC_UNUSED gpointer user_data)
{
    /* TODO */

    g_print ("get_renderer_item_info_cb");
}

/* GetFeatureList */

G_MODULE_EXPORT void get_feature_list_cb( GUPnPService *service,
                                          GUPnPServiceAction    *action,
                                          G_GNUC_UNUSED gpointer user_data)
{
    /* TODO */

    g_print ("get_feature_list_cb");
}

/*
 * ConnectionManager State Variable query handlers
 */

/* SourceProtocolInfo */

G_MODULE_EXPORT void query_source_protocol_info_cb( G_GNUC_UNUSED GUPnPService *service,
                                                    G_GNUC_UNUSED char         *variable,
                                                    GValue                     *value,
                                                    G_GNUC_UNUSED gpointer      user_data)
{
    g_print ("query_source_protocol_info_cb");

    /* TODO */

    //g_value_init (value, G_TYPE_STRING);
    //g_value_set_boolean (value, status);
}


/* SinkProtocolInfo */

G_MODULE_EXPORT void query_sink_protocol_info_cb (G_GNUC_UNUSED GUPnPService *service,
                                                  G_GNUC_UNUSED char         *variable,
                                                  GValue                     *value,
                                                  G_GNUC_UNUSED gpointer      user_data)
{
    g_print ("query_sink_protocol_info_cb");

    /* TODO */
}

/* CurrentConnectionIDs */

G_MODULE_EXPORT void query_current_connection_ids_cb (G_GNUC_UNUSED GUPnPService *service,
                                                      G_GNUC_UNUSED char         *variable,
                                                      GValue                     *value,
                                                      G_GNUC_UNUSED gpointer      user_data)
{
    g_print ("query_current_connection_ids_cb");

    /* TODO */
}

/* FeatureList */

G_MODULE_EXPORT void query_feature_list_cb (G_GNUC_UNUSED GUPnPService *service,
                                            G_GNUC_UNUSED char         *variable,
                                            GValue                     *value,
                                            G_GNUC_UNUSED gpointer      user_data)
{
    g_print ("query_feature_list_cb");

    /* TODO */
}

/* ClockUpdateID */

G_MODULE_EXPORT void query_clock_update_id_cb (G_GNUC_UNUSED GUPnPService *service,
                                               G_GNUC_UNUSED char         *variable,
                                               GValue                     *value,
                                               G_GNUC_UNUSED gpointer      user_data)
{
    g_print ("query_clock_update_id_cb");

    /* TODO */
}

/* DeviceClockInfoUpdates */

G_MODULE_EXPORT void query_device_clock_info_updates_cb (G_GNUC_UNUSED GUPnPService *service,
                                                         G_GNUC_UNUSED char         *variable,
                                                         GValue                     *value,
                                                         G_GNUC_UNUSED gpointer      user_data)
{
    g_print ("query_device_clock_info_updates_cb");

    /* TODO */
}

/*
 * RenderingControl Action handlers
 */


/*
 * RenderingControl State Variable query handlers
 */

int
main (G_GNUC_UNUSED int argc, G_GNUC_UNUSED char **argv)
{
    GOptionContext *optionContext;
    GMainLoop *main_loop;
    GError *error = NULL;
    GUPnPContext *context;
    GUPnPRootDevice *dev;
    GUPnPServiceInfo *transportService;
    GUPnPServiceInfo *connectionService;
    GUPnPServiceInfo *renderingService;

    g_print( "creating option context...\n" );

    optionContext = g_option_context_new (NULL);

    if (!g_option_context_parse (optionContext, &argc, &argv, &error))
    {
        g_print ("option parsing failed: %s\n", error->message);
        exit (1);
    }

    g_print( "creating upnp context...\n" );

    /* Create the UPnP context */
    context = gupnp_context_new (NULL, NULL, 0, &error);
    if (error) {
        g_printerr ("Error creating the GUPnP context: %s\n",
                    error->message);
        g_error_free (error);

        return EXIT_FAILURE;
    }

    g_print( "creating root device...\n" );

    /* Create root device */
    dev = gupnp_root_device_new (context, "MediaRenderer.xml", ".");
    gupnp_root_device_set_available (dev, TRUE);

    g_print( "retrieving transport service...\n" );

    transportService = gupnp_device_info_get_service (GUPNP_DEVICE_INFO (dev), "urn:schemas-upnp-org:service:AVTransport:1");
    if (!transportService) {
        g_printerr ("Cannot get transport service\n");
        return EXIT_FAILURE;
    }

    g_print( "retrieving connection service...\n" );

    connectionService = gupnp_device_info_get_service (GUPNP_DEVICE_INFO (dev), "urn:schemas-upnp-org:service:ConnectionManager:1");
    if (!connectionService) {
        g_printerr ("Cannot get connection service\n");
        return EXIT_FAILURE;
    }

    g_print( "retrieving rendering service...\n" );

    renderingService = gupnp_device_info_get_service (GUPNP_DEVICE_INFO (dev), "urn:schemas-upnp-org:service:RenderingControl:1");
    if (!renderingService) {
        g_printerr ("Cannot get rendering service\n");
        return EXIT_FAILURE;
    }

    /* Autoconnect the action and state variable handlers. */


    //gupnp_service_signals_autoconnect (GUPNP_SERVICE (transportService), NULL, &error);
    //if (error) {
    //g_printerr ("Failed to autoconnect transport signals: %s\n", error->message);
    //g_error_free (error);
    //return EXIT_FAILURE;
    //}

    g_print( "autoconnecting connection service...\n" );

    gupnp_service_signals_autoconnect (GUPNP_SERVICE (connectionService), NULL, &error);
    if (error) {
        g_printerr ("Failed to autoconnect connection signals: %s\n", error->message);
        g_error_free (error);
        return EXIT_FAILURE;
    }

    //gupnp_service_signals_autoconnect (GUPNP_SERVICE (renderingService), NULL, &error);
    //if (error) {
    //g_printerr ("Failed to autoconnect rendering signals: %s\n", error->message);
    //g_error_free (error);
    //return EXIT_FAILURE;
    //}

    g_print( "running maing loop...\n" );

    /* Run the main loop */
    main_loop = g_main_loop_new (NULL, FALSE);
    g_main_loop_run (main_loop);

    /* Cleanup */
    g_main_loop_unref (main_loop);
    g_object_unref (transportService);
    g_object_unref (connectionService);
    g_object_unref (renderingService);
    g_object_unref (dev);
    g_object_unref (context);

    return EXIT_SUCCESS;
}
